<?php
namespace Mirasvit\Search\Repository\IndexRepository;

/**
 * Interceptor class for @see \Mirasvit\Search\Repository\IndexRepository
 */
class Interceptor extends \Mirasvit\Search\Repository\IndexRepository implements \Magento\Framework\Interception\InterceptorInterface
{
    use \Magento\Framework\Interception\Interceptor;

    public function __construct(\Magento\Framework\EntityManager\EntityManager $entityManager, \Mirasvit\Search\Api\Data\IndexInterfaceFactory $indexFactory, \Mirasvit\Search\Model\ResourceModel\Index\CollectionFactory $indexCollectionFactory, \Magento\Framework\ObjectManagerInterface $objectManager, array $indexes = [])
    {
        $this->___init();
        parent::__construct($entityManager, $indexFactory, $indexCollectionFactory, $objectManager, $indexes);
    }

    /**
     * {@inheritdoc}
     */
    public function save(\Mirasvit\Search\Api\Data\IndexInterface $index) : \Mirasvit\Search\Api\Data\IndexInterface
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'save');
        return $pluginInfo ? $this->___callPlugins('save', func_get_args(), $pluginInfo) : parent::save($index);
    }
}
